<template>
  <button
    :class="[
      $style[theme],
      $style.buttonDefaults,
      disabled ? $style.disabled : null
    ]"
    :disabled="disabled"
    @click="onClickHandler"
  >
    <BaseIcon v-if="hasIcon" :name="icon" />
    <slot></slot>
  </button>
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import BaseIcon from "@/components/base/BaseIcon/index.vue";
export enum ButtonTypes {
  PRIMARY = "primary",
  SECONDARY = "secondary",
  OUTLINE_PRIMARY = "outline-primary",
  TRANSPARENT = "transparent"
}
export default Vue.extend({
  name: "BaseButton",
  components: {
    BaseIcon
  },
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    icon: {
      type: String,
      required: false
    },
    theme: {
      type: String as PropType<ButtonTypes>,
      required: false,
      default: "primary",
      validator: function(value: ButtonTypes) {
        const accepteableValues = [
          ButtonTypes.PRIMARY,
          ButtonTypes.SECONDARY,
          ButtonTypes.OUTLINE_PRIMARY,
          ButtonTypes.TRANSPARENT
        ];
        return accepteableValues.indexOf(value) !== -1;
      }
    }
  },
  data: function() {
    return {
      selectedOption: null
    };
  },
  computed: {
    hasIcon: function() {
      return this.icon ? true : false;
    }
  },
  methods: {
    onClickHandler: function(e: Event) {
      this.$emit("click", e);
    }
  }
});
</script>

<style module lang="scss">
.primary {
  composes: button--primary;
}
.outline-primary {
  composes: button--outline-primary;
}
.transparent {
  composes: button--transparent;
}
.disabled {
  composes: button--disabled;
}
.buttonDefaults {
  width: 100%;
  min-width: 120px;
}
</style>
